/* Tab=4, Linewrap=off */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <ggi/ggi.h>

#include "gbm.h"
#include "ggv.h"

#include "colors.h"

/* Public */
int read_config(void);

int read_config(void)
{
	int i;
	int foundit=0;

    cfg.default_width=640;   /* Must be at least 640 */
    cfg.default_height=480;  /* Must be at least 480 */
    cfg.default_bpp=GT_8BIT; /* Must be at least 8bit */
    cfg.select_fullscreen=0;
	strcpy(cfg.color_light,"white");
	strcpy(cfg.color_medium,"gray65");
	strcpy(cfg.color_dark,"gray55");
	strcpy(cfg.color_black,"black");
	strcpy(cfg.color_marked,"blue");

	for(i = 0; i < CLIST; i++)
		{
		if(!strcmp(cfg.color_light,clist[i].name))
			{
			foundit=1;
			default_pal[0].r=clist[i].red;
			default_pal[0].g=clist[i].green;
			default_pal[0].b=clist[i].blue;
			break;
			}
		}
	if(!foundit)
		{
		fprintf(stderr,"Unknown Light Color: %s\n",cfg.color_light);
		return GGV_ERROR;
		}
	foundit=0;

	for(i = 0; i < CLIST; i++)
		{
		if(!strcmp(cfg.color_medium,clist[i].name))
			{
			foundit=1;
			default_pal[1].r=clist[i].red;
			default_pal[1].g=clist[i].green;
			default_pal[1].b=clist[i].blue;
			break;
			}
		}
	if(!foundit)
		{
		fprintf(stderr,"Unknown Medium Color: %s\n",cfg.color_medium);
		return GGV_ERROR;
		}
	foundit=0;

	for(i = 0; i < CLIST; i++)
		{
		if(!strcmp(cfg.color_dark,clist[i].name))
			{
			foundit=1;
			default_pal[2].r=clist[i].red;
			default_pal[2].g=clist[i].green;
			default_pal[2].b=clist[i].blue;
			break;
			}
		}
	if(!foundit)
		{
		fprintf(stderr,"Unknown Dark Color: %s\n",cfg.color_dark);
		return GGV_ERROR;
		}
	foundit=0;

	for(i = 0; i < CLIST; i++)
		{
		if(!strcmp(cfg.color_black,clist[i].name))
			{
			foundit=1;
			default_pal[3].r=clist[i].red;
			default_pal[3].g=clist[i].green;
			default_pal[3].b=clist[i].blue;
			break;
			}
		}
	if(!foundit)
		{
		fprintf(stderr,"Unknown Black Color: %s\n",cfg.color_black);
		return GGV_ERROR;
		}
	foundit=0;

	for(i = 0; i < CLIST; i++)
		{
		if(!strcmp(cfg.color_marked,clist[i].name))
			{
			foundit=1;
			default_pal[4].r=clist[i].red;
			default_pal[4].g=clist[i].green;
			default_pal[4].b=clist[i].blue;
			break;
			}
		}
	if(!foundit)
		{
		fprintf(stderr,"Unknown Marked Color: %s\n",cfg.color_marked);
		return GGV_ERROR;
		}
	foundit=0;

return GGV_NOERROR;
}

